/* -*- C++ -*- */

//=============================================================================
/**
 *  @file    Asynch_Pseudo_Task.h
 *
 *  Asynch_Pseudo_Task.h,v 1.1 2002/04/16 22:47:45 shuston Exp
 *
 *  @author Alexander Libman <alibman@ihug.com.au>
 */
//=============================================================================

#ifndef TPROACTOR_ASYNCH_PSEUDO_TASK_H 
#define TPROACTOR_ASYNCH_PSEUDO_TASK_H 
#include /**/ "ace/pre.h"

#include "TProactor/TPROACTOR_Export.h"

#if !defined (ACE_LACKS_PRAGMA_ONCE)
#pragma once
#endif /* ACE_LACKS_PRAGMA_ONCE */

// we need this only for Windows NT/2000 for emulation
// asynch connect.
// new POSIX Proactor uses powerful system of AIO Providers 
#if (defined (ACE_WIN32) && !defined (ACE_HAS_WINCE))

#include "ace/Reactor.h"
#include "ace/Select_Reactor.h"
#include "ace/Task.h"
#include "ace/Manual_Event.h"

/**
 * @class TRB_Asynch_Pseudo_Task
 *
 */
class TPROACTOR_Export TRB_Asynch_Pseudo_Task : public ACE_Task<ACE_SYNCH>
{
  friend class TRB_POSIX_Asynch_Accept;
  friend class TRB_POSIX_Asynch_Connect;
  friend class TRB_WIN32_Asynch_Connect;

public:

  TRB_Asynch_Pseudo_Task();
  virtual ~TRB_Asynch_Pseudo_Task();

  int start (void);
  int stop (void);

  virtual int svc (void);

  int is_active (void);

  int register_io_handler (ACE_HANDLE handle,
                           ACE_Event_Handler *handler,
                           ACE_Reactor_Mask mask,
                           int flg_suspend);

  int remove_io_handler (ACE_HANDLE handle);
  int remove_io_handler (ACE_Handle_Set &set);
  int resume_io_handler (ACE_HANDLE handle);
  int suspend_io_handler (ACE_HANDLE handle);

protected:

  int lock_finish (void);
  int unlock_finish (void);

  int flg_active_;

  ACE_Select_Reactor select_reactor_;  
  // should be initialized before reactor_

  ACE_Reactor reactor_;

  ACE_Lock &token_;

  int              finish_count_;
  ACE_Manual_Event finish_event_;
};

#endif /* ACE_WIN32 || ACE_HAS_WINCE */

#include "ace/post.h"
#endif //TPROACTOR_ASYNCH_PSEUDO_TASK_H 
