/*********************************************************************
** Copyright (C) 2003 Terabit Pty Ltd.  All rights reserved.
**
** This file is part of the POSIX-Proactor module.
**
** This file may be distributed and used only under the terms of the  
** Terabit Public License as defined by Terabit Pty Ltd of Australia   
** and appearing in the file tlicense.txt included in the packaging of
** this module and available at http://www.terabit.com.au/license.php.
**
** Contact support@terabit.com.au if any conditions of this licensing
** are not clear to you.
**********************************************************************/

// ============================================================================
//
// = AUTHOR
//    Alexander Libman <libman@terabit.com.au>
//
// ============================================================================

#ifndef PROACTOR_TASK_H
#define PROACTOR_TASK_H

#include "TaskPool.h"
#include "TProactor/Proactor.h"
#include <vector>



class ProactorTask : public TaskPool
{
public:
  ProactorTask (TestCfg & cfg);
  virtual ~ProactorTask();

 
  TRB_Proactor * get_proactor(u_int idx);

protected:
  virtual int create_demultiplexor(void);
  virtual int delete_demultiplexor(void);
  virtual int run_event_loop(u_int thr_num);
  virtual int end_event_loop(void);

private:
  TRB_Proactor * create_proactor (u_int idx); 

  typedef std::vector<TRB_Proactor *> ProactorVector;
  
  ProactorVector proactor_vect_;
};


#endif  /* PROACTOR_TASK_H*/

